# coding=UTF-8

import urllib,urllib2,re,xbmcplugin,xbmcgui,xbmc, sys
from pluginutils.basic import *
import musicscraper
_=xbmc.getLocalizedString

# plugin constants
__plugin__ = "NovaTV"
__author__ = "ivan"
__url__ = ""
__svn_url__ = ""
__version__ = "0.1"
__svn_revision__ = "$Revision$"
__XBMC_Revision__ = "28256"

# More Actions

ACTION_BROWSE_ARTISTS=101


def do_action(url,mode,params):
    cached=True
    if mode==None or not url:
        print "Listing basic categories"
        add_dir(_(30010),'start_search' , ACTION_LIST_SEARCHES)
        add_dir(musicscraper.ARTISTS_LIST[0], musicscraper.ARTISTS_LIST[1], ACTION_BROWSE_ARTISTS)
        #list_categories(novascrapper.CATEGORIES, ACTION_LIST_PAGE)
        #add_dir(novascrapper.ALL_SERIES[0], novascrapper.ALL_SERIES[1], ACTION_BROWSE_SERIES)
           
    elif mode==ACTION_LIST_PAGE:
        print "Listing page"+url
        list_items(url, musicscraper.ScrapSearchResults, ACTION_SHOW_VIDEO, ACTION_LIST_PAGE, page=params.get('page'))
        
            
    elif mode==ACTION_SHOW_VIDEO:
        print "Playing video"+url
        hq=xbmcplugin.getSetting('high_quality')=='true'
        play_url(url, musicscraper.scrap_video,hq)
            
    elif mode == ACTION_BROWSE_ARTISTS:
        print "Listing artists"+url
        list_categories(musicscraper.scrap_artists(url), ACTION_LIST_PAGE)
        
    elif mode==ACTION_SEARCH:
        print "Searching"
        page = params.get('page')
        q=params.get('query')
        if page:
            search_url=url
        else:
            search_url=musicscraper.SEARCH_URL
            
        r=search(search_url,musicscraper.ScrapSearchResults, ACTION_SHOW_VIDEO, ACTION_SEARCH,page, q)
        if not r:
            return
        
    elif mode==ACTION_LIST_SEARCHES:
        list_searches(ACTION_SEARCH)
        cached=False
        
    elif mode==ACTION_DOWNLOAD:
        hq=xbmcplugin.getSetting('high_quality')=='true'
        if hq:
            ext='mp4'
        else:
            ext='flv'
        download_url(url, musicscraper.scrap_video, hq, ext)
        return
            
    
        
    xbmcplugin.endOfDirectory(int(sys.argv[1]), cacheToDisc=cached)

                                   
params=get_params()
url=params.get('url')
mode=params.get('mode')
if mode:
    mode=int(mode)
print "args:",sys.argv
print "Mode: "+str(mode)
print "URL: "+str(url)
print "Params: "+str(params)

try:
    do_action(url, mode, params)
except Exception, e:
    xbmc.log("PYTHON ERROR %s" % str(e), xbmc.LOGERROR)
    traceback.print_exc( file=sys.stdout)
    

